#ifndef	__DPMI32__
#error This program must be compiled for 32-bit DPMI.  Use BCC32 -WX.
#endif

#pragma inline

#include <stdio.h>
#include <conio.h>

#define INTERRUPT 0x09

typedef unsigned char  uchar;
typedef unsigned short ushort;
typedef unsigned long  ulong;

uchar  scancode=0;

struct fword {
  ulong  offset;
  ushort selector;
};

fword						oldhandler;
unsigned short	dataseg;

extern "C" void handler( void );

void setvect( uchar vector, ushort sel, ulong ofs ) {
  asm {
    push ds
    push edx
    push ax
    mov  edx,ofs
    mov  ax,sel
    mov  ds,ax
    mov  ah,0x25
    mov  al,vector
    int  0x21
    pop  ax
    pop  edx
    pop  ds
  }
}

void getvect( uchar vector, ushort *sel, ulong *ofs ) {
  ushort tempsel;
  ulong  tempofs;
  asm {
    push es
    mov ah,0x35
    mov al,vector
    int 0x21
    mov ax,es
    pop es
    mov tempsel,ax
    mov tempofs,ebx
  }
  *sel = tempsel;
  *ofs = tempofs;
}

int main(void) {

  ushort sel;
  ulong  ofs;
  char   key;

  dataseg=_DS;

  getvect( INTERRUPT, &sel, &ofs );
  oldhandler.offset = ofs;
  oldhandler.selector = sel;
  printf("interrupt %02X is at %04X:%08lX\n",INTERRUPT,sel,ofs);
  setvect( INTERRUPT, _CS, (unsigned long)&handler );
  printf("new handler installed\n");

  int done=0;
  while (!done) {
    if (scancode!=0) {
      printf("scancode = %02X\n",scancode);
      scancode=0;
    }
    if (kbhit()) {
      key=getch();
      if (key==0)
        key=getch();
      if (key==27)
        done=1;
    }
  }

  printf("removing handler\n");
  setvect( INTERRUPT, oldhandler.selector, oldhandler. offset );
  printf("handler removed\n");

  return 0;
}
